'use strict';

var _require = require('babel-plugin-macros'),
    createMacro = _require.createMacro;

var _require2 = require('./visitor'),
    visitor = _require2.visitor;

module.exports = createMacro(myMacro);

function myMacro(_ref) {
  var state = _ref.state,
      babel = _ref.babel;
  var t = babel.types;

  insertReactImport(state.file.path, t);
  state.file.path.traverse(visitor(t));
}

function insertReactImport(node, t) {
  var importSpecifiers = [t.importDefaultSpecifier(t.identifier('React'))];
  var source = t.stringLiteral('react');
  var ast = t.importDeclaration(importSpecifiers, source);
  node.unshiftContainer('body', ast);
}