'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var hookApis = ['useState', 'useReducer', 'useContext', 'useCallback', 'useImperativeMethods', 'useEffect', 'useMutationEffect', 'useLayoutEffect', 'useMemo', 'useRef'];

var miscApis = ['Component', 'PureComponent', 'createContext', 'createElement', 'createFactory', 'cloneElement', 'isValidElement', 'forwardRef', 'createRef', 'lazy', 'memo'];

var jsxApis = ['Fragment', 'Suspense', 'ConcurrentMode', 'StrictMode'];

var allApis = miscApis.concat(hookApis);

var visitor = exports.visitor = function (t) {
  return {
    Identifier(path) {
      if (checkIfReactAPI(allApis, path)) {
        var newME = t.memberExpression(t.identifier('React'), t.identifier(path.node.name));
        path.replaceWith(newME);
        path.skip();
      }
    },
    JSXIdentifier(path) {
      if (checkIfReactAPI(jsxApis, path)) {
        var newME = t.jsxMemberExpression(t.jsxIdentifier('React'), t.jsxIdentifier(path.node.name));
        path.replaceWith(newME);
        path.skip();
      }
    }
  };
};

function checkIfReactAPI(apis, path) {
  // return false if inside a member expression already
  if (path.parentPath.isMemberExpression()) return false;
  return apis.includes(path.node.name);
}